/*
   Pseudo

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2006 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Compose extends Controler {

  private Controler c1, c2 ;


  Compose (Controler c1, Controler c2) {
    this.c1 = c1 ; 
    this.c2 = c2 ; 
  }

  public boolean transition(char c) {
    if (!c1.transition(c)) {
      return false ;
    } else if (!c2.transition(c)) {
      c1.back(c) ;
      return false ;
    } else {
      return true ;
    }
  }

  public boolean accept() {
    return c1.accept() && c2.accept() ;
  }

  public void back(char c) {
    c1.back(c) ;
    c2.back(c) ;
  }

  public boolean goodWord(String w) {
    return c1.goodWord(w) && c2.goodWord(w) ;
  }

  public boolean pushWord() {
    if (!c1.pushWord()) {
      return false ;
    } else if (!c2.pushWord()) {
      c1.popWord() ;
      return false ;
    }
    return true ;
  }

  public void popWord() {
    c1.popWord() ;
    c2.popWord() ;
  }

}
