/*
   Pseudo

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2006 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class ExactWords extends Controler {
  private int rem, remChars, width ;

  ExactWords (int  nwords, int width, int nchars) {
    rem = nwords-1 ;
    remChars = nchars ;
    this.width = width ;
  }

  ExactWords (Options o) {
    this(o.nwords, o.width, o.letters.length()) ;
  }

  boolean transition(char c) {
    if (remChars == 0) return false ;
    remChars-- ;
    return true ;
  }

  boolean accept() { return rem == 0 ; }

  void back(char c) { remChars++ ; }

  boolean pushWord() {
    if (rem > 0) {
      if (rem == 1 && remChars < width) return false ;
      rem-- ;
      return true ;
    } else {
      return false ;
    }
  }


  void popWord() { rem++ ; }
}
