/*
   Pseudo

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2006 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Words {
  final static int SIZE=16 ;
  private String t[] ;
  private int sp ;
  private StringBuffer top ;
  private Coder coder ;

  Words (Coder coder) {
    this.coder = coder ;
    t = new String[SIZE] ;
    sp = 0 ;
    top = new StringBuffer() ;
  }

  private void realloc() {
    String [] newT = new String [2*t.length] ;

    for (int i = 0 ; i < t.length ; i++)
      newT[i] = t[i] ;
    t = newT ;
  }

  String pushWord() {
    if (sp >= t.length)
      realloc() ;
    String r = top.toString() ;
    top.setLength(0) ;
    t[sp++] = r ;
    return r ;
  }

  void popWord() {
    if (sp <= 0) {
      System.err.println("Empty stack") ;
      System.exit(2) ;
    }
    top.append(t[--sp]) ;
    t[sp] = null ;
  }

  void push(char c) {
    top.append(c) ;
  }

  void pop() {
    top.setLength(top.length()-1) ;
  }

  public String toString() {
    StringBuffer b = new StringBuffer () ;

    for (int i = 0 ; i < sp ; i++) {
      b.append(coder.decode(t[i]) + " ") ;
    }
    b.append(coder.decode(top.toString())) ;
    return b.toString() ;
  }
}
